//*****************************************************************************
//*****************************************************************************
//  FILENAME:  `@LIB_NAME`_CSDRPROPERTY.c
//  Version: 1.0, Updated on 2009/5/7 at 21:17:42
//  `@PSOC_VERSION`
//
//  DESCRIPTION:  This Driver senses a capacitive button press and provides
//          means for outputting "tuning" values
//
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2006. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#include "m8c.h"
#include "`@LIB_NAME`_CSDRPROPERTY.h"
#include "cmx.h"
// channel type header file
#include "CMX_CSDR_CHAN.h"
#include "CMXSystemExtern.h"

//-----------------------------------------------------------------------------
//  FUNCTION NAME: CSDRPROPERTY_Instantiate(const `@LIB_NAME`_CSDRPROPERTY_ParameterBlock * pPBlock)
//
//  DESCRIPTION:
//    CSDRPROPERTY Initialization.
//
//-----------------------------------------------------------------------------
//
//  ARGUMENTS: parameter block
//
//  RETURNS:
//
//  SIDE EFFECTS: 
//
//  THEORY of OPERATION or PROCEDURE: Sets the initial value for CSD project.
//   TODO
//
////////////////////////////////////////////////////////////////////////////////
void `@LIB_NAME`_CSDRPROPERTY_Instantiate(const `@LIB_NAME`_CSDRPROPERTY_ParameterBlock * pPBlock)
{
	CSD_bNoiseThreshold = pPBlock->pCSDProperties->NoiseThreshold;
	CSD_bBaselineUpdateThreshold = pPBlock->pCSDProperties->BaselineUpdateThreshold;
	CSD_bNegativeNoiseThreshold = pPBlock->pCSDProperties->NegativeNoiseThreshold;
	CSD_bLowBaselineReset = pPBlock->pCSDProperties->LowBaselineReset;
	CSD_bHysteresis = pPBlock->pCSDProperties->Hysteresis;
	CSD_bDebounce = pPBlock->pCSDProperties->Debounce;
}
