;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME:   CSD.inc
;;  Version: 1.3, Updated on 2009/5/7 at 21:9:1
;;  Generated by PSoC Designer 
;;
;;  DESCRIPTION:
;;    Assembler declarations for the CSD user module interface for the 24x94
;;    PSoC family of devices.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2006-2007. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

CSD_WITH_PWM:                          equ 00h
CSD_WITH_PRS8:                         equ 01h
CSD_REF_VALUE:                         equ 0x0
CSD_FEEDBACK_PIN:                      equ 0x2
CSD_FEEDBACK_P1_1:                     equ 0
CSD_FEEDBACK_P3_1:                     equ 1
CSD_FEEDBACK_P1_5:                     equ 2
CSD_FEEDBACK_P3_5:                     equ 4
CSD_FEEDBACK_P5_1:                     equ 8
CSD_FEEDBACK_P5_5:                     equ 0x10

CSD_CAPACITOR_PIN:                     equ 1
CSD_CAPACITOR_P0_5:                    equ 1
CSD_CAPACITOR_P0_7:                    equ 2

CSD_AUTORESET:                         equ 1

CSD_Poly:                              equ 0x5


;--------------------------------------------------
; Constants for Scan Speed values
;--------------------------------------------------
CSD_FAST_SPEED:                        equ 0x01
CSD_NORMAL_SPEED:                      equ 0x02
CSD_SLOW_SPEED:                        equ 0x03

;--------------------------------------------------
; Constants for Resolution values
;--------------------------------------------------
IF (CSD_WITH_PWM)
CSD_MIN_RESOLUTION:                    equ 8
CSD_MAX_RESOLUTION:                    equ 12
ELSE
CSD_MIN_RESOLUTION:                    equ 9
CSD_MAX_RESOLUTION:                    equ 16
ENDIF
;--------------------------------------------------
; Constants for CSD API's
;--------------------------------------------------

CSD_ButtonCount:                       equ 0h
CSD_SliderCount:                       equ 2h
CSD_TotalSensorCount:                  equ ah

CSD_BUTTONS_EXIST:                     equ 0h
CSD_SLIDERS_EXIST:                     equ 2h

CSD_HYSTERESIS:                                  equ ah
CSD_Debounce:                                    equ 3h
CSD_LowBaselineReset:                            equ 32h

CSD_FINGER_THRESHOLD:                            equ 64h
CSD_NOISE_THRESHOLD:                             equ 28h
CSD_NEGATIVE_NOISE_THRESHOLD:                    equ 14h
CSD_BASELINE_UPDATE_THRESHOLD:                   equ c8h

;--------------------------------------------------
; Registers Address Constants for CSD
;--------------------------------------------------

CSD_PRS_FUNC_REG:                      equ 20h              ; PRS Function Reg
CSD_PRS_IN_REG:                        equ 21h              ; PRS Input Reg
CSD_PRS_OUT_REG:                       equ 22h              ; PRS Output Reg
CSD_PRS_CONTROL_REG:                   equ 23h              ; PRS Control Reg
CSD_PRS_SHIFT_REG:                     equ 20h              ; PRS Shift Reg
CSD_PRS_POLY_REG:                      equ 21h              ; PRS Polynimial Reg
CSD_PRS_SEED_REG:                      equ 22h              ; PRS Seed Reg

CSD_ACB_CONTROL0_REG:                  equ 75h              ; CMP Function Reg
CSD_ACB_CONTROL1_REG:                  equ 76h              ; CMP Function Reg
CSD_ACB_CONTROL2_REG:                  equ 77h              ; CMP Function Reg
CSD_ACB_CONTROL3_REG:                  equ 74h              ; CMP Function Reg


DR_OFFSET:                             equ 00h
DM0_OFFSET:                            equ 00h              ; Bank 1
DM1_OFFSET:                            equ 01h              ; Bank 1
DM2_OFFSET:                            equ 03h              ; Bank 0
MUX_OFFSET:                            equ MUX_CR0          ; Bank 1

;--------------------------------------------------
; CSD Macro 'Functions'
;--------------------------------------------------
macro CSD_EnableInt_M
    M8C_ClearIntFlag  INT_CLR0, INT_MSK0_ACOLUMN_1 ;   Clear posted interrupt
    M8C_EnableIntMask INT_MSK0, INT_MSK0_ACOLUMN_1 ;   Enable ACol1 interrupt
endm

macro CSD_DisableInt_M
    M8C_DisableIntMask INT_MSK0, INT_MSK0_ACOLUMN_1 ; Disable ACol1 interrupt
endm

;--------------------------------------------------
; Constants for CSD_CMP API's
;--------------------------------------------------
CSD_CMP_CMPIntReg:                     equ  0e0h
CSD_CMP_CMPIntMask:                    equ  04h

CSD_CMP_OFF:                           equ  0
CSD_CMP_ON:                            equ  1


; end of file CSD.inc
