;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME:   SystemTimerINT.asm
;;  Version: 1.0, Updated on 2009/5/7 at 21:11:28
;;  Generated by PSoC Designer 
;;
;;  DESCRIPTION:  SleepTimer Interrupt Service Routine.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2006. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "SystemTimer.inc"
include "memory.inc"
include "m8c.inc"

;-----------------------------------------------
;  Global Symbols
;-----------------------------------------------
export  _SystemTimer_ISR


export  SystemTimer_fTick
export _SystemTimer_fTick
export  SystemTimer_bTimerValue
export _SystemTimer_bTimerValue
export  SystemTimer_bCountDown
export _SystemTimer_bCountDown
export  SystemTimer_TickCount
export _SystemTimer_TickCount

;-----------------------------------------------
; Variable Allocation
;-----------------------------------------------
AREA InterruptRAM (RAM, REL, CON)

 SystemTimer_fTick:
_SystemTimer_fTick:        BLK  1

 SystemTimer_bTimerValue:
_SystemTimer_bTimerValue:  BLK  1

 SystemTimer_bCountDown:
_SystemTimer_bCountDown:   BLK  1

 SystemTimer_TickCount:
_SystemTimer_TickCount:    BLK  SystemTimer_TICK_CNTR_SIZE



;@PSoC_UserCode_INIT@ (Do not change this line.)
;---------------------------------------------------
; Insert your custom declarations below this banner
;---------------------------------------------------

;------------------------
;  Includes
;------------------------


;------------------------
;  Constant Definitions
;------------------------


;------------------------
; Variable Allocation
;------------------------


;---------------------------------------------------
; Insert your custom declarations above this banner
;---------------------------------------------------
;@PSoC_UserCode_END@ (Do not change this line.)


AREA UserModules (ROM, REL, CON)

;-----------------------------------------------------------------------------
;  FUNCTION NAME: _SystemTimer_ISR
;
;  DESCRIPTION:
;      interrupt handler for instance SystemTimer.
;
;     This is a place holder function.  If the user requires use of an interrupt
;     handler for this function, then place code where specified.
;-----------------------------------------------------------------------------

_SystemTimer_ISR:

   or   [SystemTimer_fTick],0x01           ; Set tick flag
 
                                                ; Decrement CountDown (Sync counter)
   tst  [SystemTimer_bCountDown],0xFF
   jz   .DoTimer
   dec  [SystemTimer_bCountDown]

.DoTimer:                                       ; Decrement TimerValue, if required
   tst  [SystemTimer_bTimerValue],0xFF
   jz   .IncBigCounter
   dec  [SystemTimer_bTimerValue]

.IncBigCounter:                                 ; Increment big tick counter
IF (SystemTimer_TICK_CNTR_SIZE & 0x04)
   inc  [SystemTimer_TickCount+3]
   jnc  SystemTimer_SLEEP_ISR_END

   inc  [SystemTimer_TickCount+2]
   jnc  SystemTimer_SLEEP_ISR_END
ENDIF

IF (SystemTimer_TICK_CNTR_SIZE & (0x04|0x02))
   inc  [SystemTimer_TickCount+1]
   jnc  SystemTimer_SLEEP_ISR_END
ENDIF

   inc  [SystemTimer_TickCount+0]

SystemTimer_SLEEP_ISR_END:

   ;@PSoC_UserCode_BODY_1@ (Do not change this line.)
   ;---------------------------------------------------
   ; Insert your custom code below this banner
   ;---------------------------------------------------
   ;   NOTE: interrupt service routines must preserve
   ;   the values of the A and X CPU registers.
   
   ;---------------------------------------------------
   ; Insert your custom code above this banner
   ;---------------------------------------------------
   ;@PSoC_UserCode_END@ (Do not change this line.)

   reti

; end of file SystemTimerINT.asm

