//*****************************************************************************
//*****************************************************************************
//  FILENAME: SWPWM_Timer.h
//   Version: 2.6, Updated on 2009/5/7 at 21:12:24
//  Generated by PSoC Designer 5.0.423.0
//
//  DESCRIPTION: Timer8 User Module C Language interface file
//               for the 22/24/27/29xxx PSoC family of devices
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

#pragma fastcall16 SWPWM_Timer_EnableInt                 //                 Proxy 1
#pragma fastcall16 SWPWM_Timer_DisableInt                //                 Proxy 1
#pragma fastcall16 SWPWM_Timer_Start                     //                 Proxy 1
#pragma fastcall16 SWPWM_Timer_Stop                      //                 Proxy 1
#pragma fastcall16 SWPWM_Timer_bReadTimer                // Read  DR0       Proxy 1
#pragma fastcall16 SWPWM_Timer_bReadTimerSaveCV          // Read  DR0       Proxy 2
#pragma fastcall16 SWPWM_Timer_WritePeriod               // Write DR1       Proxy 1
#pragma fastcall16 SWPWM_Timer_bReadCompareValue         // Read  DR2       Proxy 1
#pragma fastcall16 SWPWM_Timer_WriteCompareValue         // Write DR2       Proxy 1

// The following symbols are deprecated.
// They may be omitted in future releases
//
#pragma fastcall16 bSWPWM_Timer_ReadCounter              // Read  DR0 "Obsolete"
#pragma fastcall16 bSWPWM_Timer_CaptureCounter           // Read  DR0 "Obsolete"
#pragma fastcall16 bSWPWM_Timer_ReadTimer                // Read  DR0 (Deprecated)
#pragma fastcall16 bSWPWM_Timer_ReadTimerSaveCV          // Read  DR0 (Deprecated)
#pragma fastcall16 bSWPWM_Timer_ReadCompareValue         // Read  DR2 (Deprecated)


//-------------------------------------------------
// Prototypes of the SWPWM_Timer API.
//-------------------------------------------------

extern void SWPWM_Timer_EnableInt(void);
extern void SWPWM_Timer_DisableInt(void);
extern void SWPWM_Timer_Start(void);
extern void SWPWM_Timer_Stop(void);
extern BYTE SWPWM_Timer_bReadTimer(void);
extern BYTE SWPWM_Timer_bReadTimerSaveCV(void);
extern void SWPWM_Timer_WritePeriod(BYTE bPeriod);
extern BYTE SWPWM_Timer_bReadCompareValue(void);
extern void SWPWM_Timer_WriteCompareValue(BYTE bCompareValue);

// The following functions are deprecated.
// They may be omitted in future releases
//
extern BYTE bSWPWM_Timer_ReadCompareValue(void);       // Deprecated
extern BYTE bSWPWM_Timer_ReadTimerSaveCV(void);        // Deprecated
extern BYTE bSWPWM_Timer_ReadCounter(void);            // Obsolete
extern BYTE bSWPWM_Timer_ReadTimer(void);              // Deprecated
extern BYTE bSWPWM_Timer_CaptureCounter(void);         // Obsolete


//--------------------------------------------------
// Constants for SWPWM_Timer API's.
//--------------------------------------------------

#define SWPWM_Timer_CONTROL_REG_START_BIT      ( 0x01 )
#define SWPWM_Timer_INT_REG_ADDR               ( 0x0e1 )
#define SWPWM_Timer_INT_MASK                   ( 0x02 )


//--------------------------------------------------
// Constants for SWPWM_Timer user defined values
//--------------------------------------------------

#define SWPWM_Timer_PERIOD                     ( 0x05 )
#define SWPWM_Timer_COMPARE_VALUE              ( 0x00 )


//-------------------------------------------------
// Register Addresses for SWPWM_Timer
//-------------------------------------------------

#pragma ioport  SWPWM_Timer_COUNTER_REG:    0x024          //DR0 Count register
BYTE            SWPWM_Timer_COUNTER_REG;
#pragma ioport  SWPWM_Timer_PERIOD_REG: 0x025              //DR1 Period register
BYTE            SWPWM_Timer_PERIOD_REG;
#pragma ioport  SWPWM_Timer_COMPARE_REG:    0x026          //DR2 Compare register
BYTE            SWPWM_Timer_COMPARE_REG;
#pragma ioport  SWPWM_Timer_CONTROL_REG:    0x027          //Control register
BYTE            SWPWM_Timer_CONTROL_REG;
#pragma ioport  SWPWM_Timer_FUNC_REG:   0x124              //Function register
BYTE            SWPWM_Timer_FUNC_REG;
#pragma ioport  SWPWM_Timer_INPUT_REG:  0x125              //Input register
BYTE            SWPWM_Timer_INPUT_REG;
#pragma ioport  SWPWM_Timer_OUTPUT_REG: 0x126              //Output register
BYTE            SWPWM_Timer_OUTPUT_REG;
#pragma ioport  SWPWM_Timer_INT_REG:       0x0e1           //Interrupt Mask Register
BYTE            SWPWM_Timer_INT_REG;


//-------------------------------------------------
// SWPWM_Timer Macro 'Functions'
//-------------------------------------------------

#define SWPWM_Timer_Start_M \
   ( SWPWM_Timer_CONTROL_REG |=  SWPWM_Timer_CONTROL_REG_START_BIT )

#define SWPWM_Timer_Stop_M  \
   ( SWPWM_Timer_CONTROL_REG &= ~SWPWM_Timer_CONTROL_REG_START_BIT )

#define SWPWM_Timer_EnableInt_M   \
   M8C_EnableIntMask(  SWPWM_Timer_INT_REG, SWPWM_Timer_INT_MASK )

#define SWPWM_Timer_DisableInt_M  \
   M8C_DisableIntMask( SWPWM_Timer_INT_REG, SWPWM_Timer_INT_MASK )


// end of file SWPWM_Timer.h
